<template>
    <div>
        <h2 class="text-center">Article List</h2>

        <table class="table">
            <thead>
            <tr>
                <th>ID</th>
                <th>Title</th>
                <th>Detail</th>
                <th><!-- Actions --></th>
            </tr>
            </thead>
            <tbody v-if="isLoaded">
            <tr v-for="article in articles.data" :key="article.id">
                <td>
                    <router-link :to="{name: 'show', params: { id: article.id }}">{{ article.id }}</router-link>
                </td>
                <td>{{ article.title }}</td>
                <td>{{ article.detail }}</td>
                <td>
                    <div class="btn-group" role="group">
                        <router-link :to="{name: 'edit', params: { id: article.id }}" class="btn btn-success">Edit
                        </router-link>
                        <button class="btn btn-danger" @click="deleteProduct(article.id)">Delete</button>
                    </div>
                </td>
            </tr>
            </tbody>
            <tbody v-else>
            <tr>
                <td colspan="4">
                    <div class="preloader"></div>
                </td>
            </tr>
            </tbody>
        </table>

        <pagination :data="articles" @pagination-change-page="getResults"></pagination>
    </div>
</template>

<script>
export default {
    data() {
        return {
            articles: {},
            isLoaded: false,
        }
    },
    created() {
        // Отметим текущее состояние для history
        let historyPage = parseInt(this.$route.params.page) || 1;
        let historyUrl = '/';
        if (historyPage > 1) {
            historyUrl = '/page/' + historyPage;
        }
        history.replaceState({'page': historyPage}, document.title, historyUrl);

        // Получение основных данных
        this.getResults(`${this.$route.params.page}`);

        // Бинд перехода по history с соответствущей реакции компонента
        // let thisVueComponent = this;
        window.onpopstate = event => {
            this.getResults(event.state.page, false);
        };
    },
    methods: {
        /**
         *
         * @param page - номер текущей страницы пагинации
         * @param changeHistoryState - изменять/добавлять ли состояние history
         */
        getResults(page = 1, changeHistoryState = true) {
            this.isLoaded = false;
            axios.get(`/api/articles?page=${page}`)
                .then(response => {
                    // \Illuminate\Contracts\Pagination\LengthAwarePaginator
                    this.articles = response.data;

                    // Если записей на этой странице нет, пробуем вызвать предыдущую страницу
                    if (this.articles.data.length < 1 && page > 1) {
                        this.getResults(page - 1);
                    } else {
                        // Если всё в порядке, ставим флаг окончания загрузки
                        this.isLoaded = true;

                        // Добавить state в history, если нужно
                        if (changeHistoryState) {
                            if (page > 1) {
                                history.pushState({'page': page}, document.title, '/page/' + page);
                            } else {
                                history.pushState({'page': 1}, document.title, '/');
                            }
                        }
                    }
                });
        },
        /**
         *
         * @param id
         */
        deleteProduct(id) {
            this.axios
                .delete(`/api/articles/${id}`)
                .then(response => {
                    this.getResults(this.articles.current_page);
                });
        }
    }
}
</script>
